echo BUILDING VECOPS ARCHIVE...
g++ -c vecops.cpp ops.cpp
ar -r vecops.a vecops.o ops.o
echo MAKING LEX FILE FOR NEWSPLIT...
grep -E -h -f token.grep tex.l vec.l cf.l > newsplit.lmiddle
cat newsplit.lstart newsplit.lmiddle newsplit.lend > newsplit.l
echo YACCING NEWSPLIT...
yacc -d newsplit.y
echo LEXING NEWSPLIT...
flex  newsplit.l
echo G++ing NEWSPLIT...
g++  -O0 lex.yy.c  y.tab.c vecops.a -o../bin/newsplit.exe
echo YACCING CF...
yacc -d cf.y
echo LEXING CF...
flex  cf.l
echo G++ing CF...
g++  -O0 lex.yy.c  y.tab.c vecops.a -o../bin/cf.exe
echo YACCING VEC...
yacc -d vec.y
echo LEXING VEC...
flex  vec.l
echo G++ing VEC...
g++  -O0 lex.yy.c  y.tab.c vecops.a -o../bin/vec.exe
echo YACCING TEX...
yacc -d tex.y
echo LEXING TEX...
flex  tex.l
echo G++ing TEX...
g++  -O0 lex.yy.c  y.tab.c vecops.a -o../bin/tex.exe
echo G++ing COMBINE...
g++ -O0 combine.c -o../bin/combine.exe
echo YACCING PARSECONTROL...
yacc -d parsecontrol.y
echo LEXING PARSECONTROL...
flex parsecontrol.l
echo G++ing PARSECONTROL...
g++ -O0 lex.yy.c y.tab.c -o../bin/pc.exe
echo MAKING incf/token files...
grep INST cf.l | cut -d" " -f1 > cfinstsincf
gawk 'BEGIN {printf("(")}; {printf ("^%s|",$1) }; END {print "BLAHSTR)"}' cfinstsincf > ../res/cftokens.grep
grep ALU2OP vec.l | cut -d" " -f1 > vecinstsincf
grep ALU3OP vec.l | cut -d" " -f1 >> vecinstsincf
grep "\"VEC" vec.l | cut -d"\"" -f2 >> vecinstsincf
grep  -e "\[-\]" vec.l | cut -d" " -f1 >> vecinstsincf
gawk 'BEGIN {printf("(")}; {printf ("^%s|",$1) }; END {print "^[ \\t]*$)"}' vecinstsincf > ../res/alutokens.grep
grep -E '(VCOP|TEXOP|MEMRDOP)' tex.l | cut -d" " -f1 > texinstsincf
gawk 'BEGIN {printf("(")}; {printf ("^%s |",$1) }; END {print "BLAHSTR)"}' texinstsincf > ../res/textokens.grep
echo DONE
